## Contributing to memoptimizer

We welcome your contributions! There are multiple ways to contribute.

## Issues

For bugs or enhancement requests, please file a GitHub issue unless it's security related. When filing a bug remember that the better written the bug is, the more likely it is to be fixed. If you think you've found a security vulnerability, do not raise a GitHub issue and follow the instructions on our [Security Policy](./SECURITY.md).

## Contributing Code

We welcome your code contributions. Contributions are subject to following requirements:

* Contributions must be made under GNU Public License version 2.
* Contributions must be in the form of a patch or git pull request.
* Contributors sign off on changes submitted. The Developer Certificate of Origin (DCO) is a standard requirement to certify that you wrote or have the right to submit the code you are contributing to the project. You can find the full text of the DCO here: https://developercertificate.org/

You sign-off by adding the following to your commit messages:

This is my commit message

`Signed-off-by: Random J Developer <random@developer.example.org>`

Git has a `-s` command line option to do this automatically.

`git commit -s -m 'This is my commit message'`


To contribute to this project, obtain source code either from the source package or from the public git repository maintained at https://github.com/oracle/memoptimizer See the `README.md` file for details on how to build and verify your changes.


### Pull request process

1. Fork this repository
1. Create a branch in your fork to implement the changes. We recommend using
the issue number as part of your branch name, e.g. `1234-fixes`
1. Ensure that any documentation is updated with the changes that are required
by your fix.
1. Ensure that any samples are updated if the base image has been changed.
1. Submit the pull request. *Do not leave the pull request blank*. Explain exactly
what your changes are meant to do and provide simple steps on how to validate
your changes. Ensure that you reference the issue you created as well.
1. We will assign the pull request to 2-3 people for review before it is merged.

## Code of Conduct

Follow the [Golden Rule](https://en.wikipedia.org/wiki/Golden_Rule). If you'd like more specific guidelines see the [Contributor Covenant Code of Conduct](https://www.contributor-covenant.org/version/1/4/code-of-conduct/)
